Class | ActionController::Response
In: | lib/action_controller/response.rb
Parent: | Rack::Response

Represents an HTTP response generated by a controller action. One can use an ActionController::Response object to retrieve the current state of the response, or customize the response. An Response object can either represent a "real" HTTP response (i.e. one that is meant to be sent back to the web browser) or a test response (i.e. one that is generated from integration tests). See CgiResponse and TestResponse, respectively.

Response is mostly a Ruby on Rails framework implement detail, and should never be used directly in controllers. Controllers should use the methods defined in ActionController::Base instead. For example, if you want to set the HTTP response‘s content MIME type, then use ActionControllerBase#headers instead of Response#headers.

Nevertheless, integration tests may want to inspect controller responses in more detail, and that‘s when Response can be useful for application developers. Integration test methods such as ActionController::Integration::Session#get and ActionController::Integration::Session#post return objects of type TestResponse (which are of course also of type Response).

For example, the following demo integration "test" prints the body of the controller response to the console:

     class DemoControllerTest < ActionController::IntegrationTest
       def test_print_root_path_to_console
         get('/')
         puts @response.body
       end
     end

### Methods

assign_default_content_type_and_charset! charset charset= content_type content_type= each etag etag= etag? last_modified last_modified= last_modified? location location= new prepare! redirect sending_file? set_cookie write

### Constants

DEFAULT_HEADERS | = | { "Cache-Control" => "no-cache" }

### Attributes

assigns | [RW] |
layout | [RW] |
redirected_to | [RW] |
redirected_to_method_params | [RW] |
request | [RW] |
session | [RW] |
template | [RW] |

### Public Class methods

new()

### Public Instance methods

assign_default_content_type_and_charset!()
charset()
charset=(charset)

Set the charset of the Content-Type header. Set to nil to remove it. If no content type is set, it defaults to HTML.

content_type()

Returns the response‘s content MIME type, or nil if content type has been set.

content_type=(mime_type)

Sets the HTTP response‘s content MIME type. For example, in the controller you could write this:

     response.content_type = "text/plain"

If a character set has been defined for this response (see charset=) then the character set information will also be included in the content type information.

each(&callback)
etag()
etag=(etag)
etag?()
last_modified()
last_modified=(utc_time)
last_modified?()
location()
location=(url)
prepare!()
redirect(url, status)
sending_file?()
set_cookie(key, value)
write(str)

[Validate]